scala.reflect.macros

# Aliases

#### trait Aliases extends AnyRef

EXPERIMENTAL

A slice of the Scala macros context that defines shorthands for the most frequently used types and functions of the underlying compiler universe.

Self Type
  Context
Source
  Aliases.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Context
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Aliases
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type CompilationUnit = Universe.CompilationUnit

   The type of compilation units.

2. #### type Expr[+T] = Universe.Expr[T]

   Expr wraps an abstract syntax tree and tags it with its type.

3. #### type Modifiers = Universe.Modifiers

   The type of tree modifiers.

4. #### type Name = Universe.Name

   The abstract type of names.

5. #### type Position = Universe.Position

   Defines a universe-specific notion of positions.

6. #### type Run = Universe.Run

   The type of compilation runs.

7. #### type Scope = Universe.Scope

   The base type of all scopes.

8. #### type Symbol = Universe.Symbol

   The type of symbols representing declarations.

9. #### type TermName = Universe.TermName

   The abstract type of names representing terms.

10. #### type Tree = Universe.Tree

    The type of Scala abstract syntax trees.

11. #### type Type = Universe.Type

    The type of Scala types, and also Scala type signatures.

    The type of Scala types, and also Scala type signatures. (No difference is internally made between the two).

12. #### type TypeName = Universe.TypeName

    The abstract type of names representing types.

13. #### type TypeTag[T] = Universe.TypeTag[T]

    The type of type tags.

14. #### type WeakTypeTag[T] = Universe.WeakTypeTag[T]

    The type of weak type tags.

### Abstract Value Members

1. #### abstract def Expr[T](tree: Context.Tree)(implicit arg0: Context.WeakTypeTag[T]): Context.Expr[T]

   A shorthand to create an expr.

   A shorthand to create an expr.

   Unlike the conventional expr factory, which requires a scala.reflect.api.TreeCreator, this one accepts a regular tree, but the resulting exprs are unable of being migrated to other universes/mirrors (the functionality normally not needed for macros, since there is only one compile-time universe and only one compile-time mirror).

2. #### abstract def TypeTag[T](tpe: Context.Type): Context.TypeTag[T]

   A shorthand to create a type tag.

   A shorthand to create a type tag.

   Unlike the conventional type tag factory, which requires a scala.reflect.api.TypeCreator, this one accepts a regular type, but the resulting type tags are unable of being migrated to other universes/mirrors (the functionality normally not needed for macros, since there is only one compile-time universe and only one compile-time mirror).

3. #### abstract def WeakTypeTag[T](tpe: Context.Type): Context.WeakTypeTag[T]

   A shorthand to create a weak type tag.

   A shorthand to create a weak type tag.

   Unlike the conventional type tag factory, which requires a scala.reflect.api.TypeCreator, this one accepts a regular type, but the resulting type tags are unable of being migrated to other universes/mirrors (the functionality normally not needed for macros, since there is only one compile-time universe and only one compile-time mirror).

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Aliases to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (Aliases, B)

   Implicit information
     This member is added by an implicit conversion from Aliases to ArrowAssoc[Aliases] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline ()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### val Expr: Universe.Expr.type

   Constructor/Extractor for `Expr`.

9. #### val TypeTag: Universe.TypeTag.type

   Constructor/Extractor for `TypeTag`.

10. #### val WeakTypeTag: Universe.WeakTypeTag.type

    Constructor/Extractor for `WeakTypeTag`.

11. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### def ensuring(cond: (Aliases) ⇒ Boolean, msg: ⇒ Any): Aliases

    Implicit information
      This member is added by an implicit conversion from Aliases to Ensuring[Aliases] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (Aliases) ⇒ Boolean): Aliases

    Implicit information
      This member is added by an implicit conversion from Aliases to Ensuring[Aliases] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): Aliases

    Implicit information
      This member is added by an implicit conversion from Aliases to Ensuring[Aliases] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): Aliases

    Implicit information
      This member is added by an implicit conversion from Aliases to Ensuring[Aliases] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

19. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

20. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Aliases to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline ()

21. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

23. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

24. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

25. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

26. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

27. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

28. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

29. #### def typeOf[T](implicit ttag: Context.TypeTag[T]): Context.Type

    Shortcut for `implicitly[TypeTag[T]].tpe`

30. #### def typeTag[T](implicit ttag: Context.TypeTag[T]): Context.TypeTag[T]

    Shortcut for `implicitly[TypeTag[T]]`

31. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

32. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

33. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

34. #### def weakTypeOf[T](implicit attag: Context.WeakTypeTag[T]): Context.Type

    Shortcut for `implicitly[WeakTypeTag[T]].tpe`

35. #### def weakTypeTag[T](implicit attag: Context.WeakTypeTag[T]): Context.WeakTypeTag[T]

    Shortcut for `implicitly[WeakTypeTag[T]]`

36. #### def →[B](y: B): (Aliases, B)

    Implicit information
      This member is added by an implicit conversion from Aliases to ArrowAssoc[Aliases] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Aliases to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (aliases: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Aliases to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (aliases: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: Aliases

   Implicit information
     This member is added by an implicit conversion from Aliases to ArrowAssoc[Aliases] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (aliases: ArrowAssoc[Aliases]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: Aliases

   Implicit information
     This member is added by an implicit conversion from Aliases to Ensuring[Aliases] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (aliases: Ensuring[Aliases]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Aliases to StringAdd

### Inherited by implicit conversion any2stringfmt from Aliases to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from Aliases to ArrowAssoc[Aliases]

### Inherited by implicit conversion any2Ensuring from Aliases to Ensuring[Aliases]

### Ungrouped